ompi/mca/btl/sm/btl_sm.c File Reference.TH "ompi/mca/btl/sm/btl_sm.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/btl/sm/btl_sm.c \- Note that there are effectively two versions of the btl sm module -- one that assumes that the base address of the shared memory segment is the same between pairs of processes (i.e., mmap() returned the same virtual address for the same segment in both processes), and one that assumes that the base addresses are different. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include <string.h>\fP
.br
\fC#include <stdlib.h>\fP
.br
\fC#include <sys/types.h>\fP
.br
\fC#include <sys/stat.h>\fP
.br
\fC#include <fcntl.h>\fP
.br
\fC#include <errno.h>\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'ompi/datatype/convertor.h'\fP
.br
\fC#include 'include/sys/atomic.h'\fP
.br
\fC#include 'opal/util/output.h'\fP
.br
\fC#include 'opal/util/if.h'\fP
.br
\fC#include 'util/proc_info.h'\fP
.br
\fC#include 'opal/util/printf.h'\fP
.br
\fC#include 'util/sys_info.h'\fP
.br
\fC#include 'ompi/class/ompi_fifo.h'\fP
.br
\fC#include 'ompi/class/ompi_free_list.h'\fP
.br
\fC#include 'ompi/mca/pml/pml.h'\fP
.br
\fC#include 'ompi/mca/btl/btl.h'\fP
.br
\fC#include 'mca/mpool/base/base.h'\fP
.br
\fC#include 'mca/common/sm/common_sm_mmap.h'\fP
.br
\fC#include 'btl_sm.h'\fP
.br
\fC#include 'btl_sm_endpoint.h'\fP
.br
\fC#include 'btl_sm_frag.h'\fP
.br
\fC#include 'btl_sm_fifo.h'\fP
.br
\fC#include 'ompi/proc/proc.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_btl_sm_add_procs_same_base_addr\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers, ompi_bitmap_t *reachability)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_add_procs\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers, ompi_bitmap_t *reachability)"
.br
.ti -1c
.RI "int \fBmca_btl_sm_del_procs\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_btl_base_endpoint_t\fP **peers)"
.br
.RI "\fIPML->BTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_finalize\fP (struct \fBmca_btl_base_module_t\fP *btl)"
.br
.RI "\fICleanup any resources held by the BTL. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_register\fP (struct \fBmca_btl_base_module_t\fP *btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIRegister a callback function that is called on receipt of a fragment. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_sm_alloc\fP (struct \fBmca_btl_base_module_t\fP *btl, size_t size)"
.br
.RI "\fIAllocate a segment. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_free\fP (struct \fBmca_btl_base_module_t\fP *btl, \fBmca_btl_base_descriptor_t\fP *des)"
.br
.RI "\fIReturn a segment allocated by this BTL. \fP"
.ti -1c
.RI "\fBmca_btl_base_descriptor_t\fP * \fBmca_btl_sm_prepare_src\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, mca_mpool_base_registration_t *registration, struct ompi_convertor_t *convertor, size_t reserve, size_t *size)"
.br
.RI "\fIPack data. \fP"
.ti -1c
.RI "int \fBmca_btl_sm_send\fP (struct \fBmca_btl_base_module_t\fP *btl, struct \fBmca_btl_base_endpoint_t\fP *endpoint, struct \fBmca_btl_base_descriptor_t\fP *descriptor, mca_btl_base_tag_t tag)"
.br
.RI "\fIInitiate a send to the peer. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "\fBmca_btl_sm_t\fP \fBmca_btl_sm\fP [2]"
.br
.ti -1c
.RI "mca_btl_sm_module_resource_t \fBmca_btl_sm_module_resource\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
Note that there are effectively two versions of the btl sm module -- one that assumes that the base address of the shared memory segment is the same between pairs of processes (i.e., mmap() returned the same virtual address for the same segment in both processes), and one that assumes that the base addresses are different. 

In the former, no translation is necessary -- all pointers can be stored directly as-is and used in both processes.
.PP
In the latter, we calculate the difference between the base virtual address of the two process' shared memory segments and cache it. This difference is used to access memory and pointers written by the other process.
.PP
Specifically, a good portion of this btl is implemented in the ompi_fifo_t and ompi_circular_buffer_t classes. These classes *always* store absolute virtual addresses in their data structures. The virtual addresses are always meaningful in the *sender's* process space. If the base address is the same in both processes, then we get the happy side effect that the virtual addresses are also valid in the receiver's process space, and therefore no address translation needs to be done when the reader accesses the data.
.PP
However, in the case where the base addresses are different, the receiver must translate every pointer address in the ompi_fifo_t and ompi_circular_buffer_t data structures (even when writing back to those data structures, such as updating a head or tail pointer).
.PP
In short, we use a 'receiver makes right' scheme, and in some cases, the receiver doesn't have to do anything.
.SH "Function Documentation"
.PP 
.SS "int mca_btl_sm_add_procs_same_base_addr (struct \fBmca_btl_base_module_t\fP * btl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_btl_base_endpoint_t\fP ** peers, ompi_bitmap_t * reachability)"
.PP
PML->BTL notification of change in the process list. 
.PP
PML->BTL Notification that a receive fragment has been matched. Called for message that is send from process with the virtual address of the shared memory segment being the same as that of the receiver.
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) 
.br
\fIproc\fP (IN) 
.br
\fIpeer\fP (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "\fBmca_btl_base_descriptor_t\fP* mca_btl_sm_alloc (struct \fBmca_btl_base_module_t\fP * btl, size_t size)"
.PP
Allocate a segment. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIsize\fP (IN) Request segment size. 
.RE
.PP

.SS "int mca_btl_sm_del_procs (struct \fBmca_btl_base_module_t\fP * btl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_btl_base_endpoint_t\fP ** peers)"
.PP
PML->BTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL instance 
.br
\fIproc\fP (IN) Peer process 
.br
\fIpeer\fP (IN) Peer addressing information. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful 
.RE
.PP

.SS "int mca_btl_sm_finalize (struct \fBmca_btl_base_module_t\fP * btl)"
.PP
Cleanup any resources held by the BTL. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module.
.RE
.PP
Prior to unloading a BTL module, the MCA framework will call the BTL finalize method of the module. Any resources held by the BTL should be released and if required the memory corresponding to the BTL module freed. 
.SS "int mca_btl_sm_free (struct \fBmca_btl_base_module_t\fP * btl, \fBmca_btl_base_descriptor_t\fP * des)"
.PP
Return a segment allocated by this BTL. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIsegment\fP (IN) Allocated segment. 
.RE
.PP

.SS "struct \fBmca_btl_base_descriptor_t\fP* mca_btl_sm_prepare_src (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * endpoint, mca_mpool_base_registration_t * registration, struct ompi_convertor_t * convertor, size_t reserve, size_t * size)"
.PP
Pack data. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.RE
.PP

.SS "int mca_btl_sm_register (struct \fBmca_btl_base_module_t\fP * btl, mca_btl_base_tag_t tag, \fBmca_btl_base_module_recv_cb_fn_t\fP cbfunc, void * cbdata)"
.PP
Register a callback function that is called on receipt of a fragment. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful
.RE
.PP
When the process list changes, the PML notifies the BTL of the change, to provide the opportunity to cleanup or release any resources associated with the peer. 
.SS "int mca_btl_sm_send (struct \fBmca_btl_base_module_t\fP * btl, struct \fBmca_btl_base_endpoint_t\fP * endpoint, struct \fBmca_btl_base_descriptor_t\fP * descriptor, mca_btl_base_tag_t tag)"
.PP
Initiate a send to the peer. 
.PP
\fBParameters:\fP
.RS 4
\fIbtl\fP (IN) BTL module 
.br
\fIpeer\fP (IN) BTL peer addressing 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
